﻿namespace ProjectCleaningCar;
/// <summary>
/// Класс-сущность "Подметательно-уборочная машина"
/// </summary>
public class EntityCleaningCar
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }
    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }
    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак (опция) наличия бака
    /// </summary>
    public bool Tank { get; private set; }
    /// <summary>
    /// Признак (опция) наличия щётки
    /// </summary>
    public bool SweepingBrush { get; private set; }
    /// <summary>
    /// Признак (опция) наличия проблескового маячка
    /// </summary>
    public bool Flashlight { get; private set; }
    /// <summary>
    /// Шаг перемещения подметательно-уборочной машины
    /// </summary>
    public double Step => Speed * 200 / Weight;
    /// <summary>
    /// Инициализация полей объекта-класса подметально-уборочной машины
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="tank">Признак наличия бака под воду</param>
    /// <param name="sweepingBrush">Признак наличия подметательной щётки</param>
    /// <param name="flashlight">Признак наличия проблескового маячка</param>
    public void Init(int speed, double weight, Color bodyColor, Color additionalColor,
        bool tank, bool sweepingBrush, bool flashlight)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        AdditionalColor = additionalColor;
        Tank = tank;
        SweepingBrush = sweepingBrush;
        Flashlight = flashlight;
    }
}
